/* tongWenLoad Object which deal with the document "load" event. */

/* Add load event listener for auto convert. */

function isOppCharset(curDoc, zhflag) {
    var ret = true;
    try {
	var cs = curDoc.characterSet;
	if (cs in zh_all) {
	    if (zhflag == SIMFLAG && cs in zh_encodes["cn"])
		ret = false;
	    else if (zhflag == TRAFLAG && 
		    (cs in zh_encodes["tw"] || cs in zh_encodes["hk"]))
		ret = false;
	    else
		ret = true;
	}
    }catch(e){myalert(e + curDoc + zhflag, "isoppcharset");}
    return ret;
}
	
function addTongWenAuto(zhflag){
    if (!this.zhflag) {
	document.addEventListener("load", this, true);
    }
    this.zhflag = zhflag;
    /* Update options */
    tongwen_options.set_auto_convert(zhflag);
    /* FIXME: Do we really want to convert the current doc immediately? */
    try {
	/* Some race on startup. Why tongwen.js is not loaded after onload? */
	if (tongWen != undefined) {
	    var curDoc = getFocusedDoc();
	    // If no HTMLDocument, we just stop.
	    if (curDoc && !(curDoc instanceof XULDocument)) {
		myalert(curDoc.characterSet, "addtongwenauto"); 
		if (!ZHENCODINGONLY || (curDoc.characterSet in zh_all))
		    if (!OPPCHARSETONLY || isOppCharset(curDoc, zhflag))
			tongWen(zhflag);
	    }
	}
    } catch(e) { myalert(e, "addtongwenauto"); }
}

/* Remove load listener. */
function removeTongWenAuto(){
    if (!this.zhflag)
	document.removeEventListener("load", this, true);
    this.zhflag = null;
    tongwen_options.set_auto_convert("off");
}

/* The actual load event handler. */
function autoAction(evt) {
    if((evt.originalTarget instanceof HTMLDocument) && this.zhflag != null)
    {
	/* Ignore non Chinese page if asked. */
	if (!ZHENCODINGONLY || (evt.originalTarget.characterSet in zh_all)) {
	    if (!OPPCHARSETONLY || isOppCharset(evt.originalTarget, this.zhflag))
		doFrames(evt.originalTarget, this.zhflag, 0);
	    myalert("Update Page: " + this.zhflag, "autoaction");
	}
	myalert(this.zhflag, "autoaction");
    }
}

/* The auto convert on page load object. */
/* Change this.zhflag to switch simplified/traditional Chinese. */
function tongWenAutoLoad() {
    this.zhflag = null;
    this.handleEvent = autoAction; /* mozilla need this specific name! */
    this.add = addTongWenAuto;
    this.remove = removeTongWenAuto;
    return this;
}

/* Initialize auto load stuff, of course. */
function initAutoLoad() {
    document.removeEventListener('load', initAutoLoad, true);
    var acstat = tongwen_options.get_auto_convert();
    try {
    switch (acstat) {
	case SIMFLAG:
	    var widget = document.getElementById("tongwen-auto-simplified-item");
	    widget.setAttribute("checked", true);
	    tongwen_auto.add(acstat);
	    break;
	case TRAFLAG:
	    var widget = document.getElementById("tongwen-auto-traditional-item");
	    widget.setAttribute("checked", true);
	    tongwen_auto.add(acstat);
	    break;
    }
    }catch(e){myalert('initAutoLoad: ' + e, 'initautoload')}
}

tongwen_auto = new tongWenAutoLoad();
document.addEventListener('load', initAutoLoad, true);

/*************************************************************************/
/*************************************************************************/

/* Something about gecko event queue. Not really useful. */
function getEventQ() {
    const ciid = '@mozilla.org/event-queue-service;1';
    const evqif = Components.interfaces.nsIEventQueueService;
    var eventq = Components.classes[ciid].getService();
    eventq.QueryInterface(evqif);
    return eventq;
}
    
function updateEQ(eventq) {
    if (!eventq)
	eventq = getEventQ();
    var q = eventq.getSpecialEventQueue(eventq.CURRENT_THREAD_EVENT_QUEUE);
    if (q.pendingEvents())
	q.processPendingEvents();
}

// testEvent();
function testEvent() {
    document.addEventListener("load", me, true);
}

function me(arg) {
    myalert("page loaded.\n" + arg.originalTarget + "\n" +
	content.document.location +"\n"+ 
	arg.originalTarget.location );
}

